import numpy as np
from solution.icp_smpl_gradient import icp_smpl_gradient
from os.path import join
from mayavi.mlab import figure

if __name__ == '__main__':
    import sys
    objectives = {'1a': ['sum_on_data'],
                  '1b': ['sum_on_data'],
                  '1c': ['sum_on_data', 'pose_prior'],
                  '1d': ['sum_on_data', 'pose_prior', 'shape_prior'],
                  '1e': ['sum_on_data', 'sum_on_model', 'pose_prior', 'shape_prior'],
                  '1f': ['sum_on_data', 'pose_prior_data']}

    if len(sys.argv) < 2 or sys.argv[1] not in objectives:
        print('the first argument should be one of 1a, 1b, 1c, 1d, 1e')
        sys.exit(1)
    exercise = sys.argv[1]
    data_path = './data/'
    # create a mayavi figure
    fig = figure(size=(800, 800))

    # load ver1ices
    if exercise == '1a':
        verts0 = np.load(join(data_path, 'simpleposev.npy'))
        faces0 = np.load(join(data_path, 'simpleposef.npy'))
    else:
        verts0 = np.load(join(data_path, 'middlepose3v.npy'))
        faces0 = np.load(join(data_path, 'middlepose3f.npy'))

    from smpl.serialization import load_model
    # CHANGE FOR DOWNLOADED MODEL PATH!
    sm = load_model('data/basicmodel_m_lbs_10_207_0_v1.0.0.pkl')


    (res, verts0_xform, tform) = icp_smpl_gradient(verts0, sm, faces0,
                                                   fig, n_iters=30,
                                                   objectives=objectives[exercise])
    raw_input('press enter')
